#include "pch.hpp"
#include "chalcopyrite.hpp"
#include "mainwnd.hpp"
#include "scorelinedlg.hpp"
#include "scoreline.hpp"
#include "characters.hpp"
#include "TextFileWriter.hpp"
#include "Formatter.hpp"
#include "SwrAddrDef.h"
#include "resource.h"

#define UC_SHOWALL  0xDEA0
#define UC_SHOWL30  0xDEA1
#define UC_SHOWL50  0xDEA2
#define UC_SHOWL100 0xDEA3
#define UC_SHOWMAX  0xDEA4

#define UC_DIRP1	0xDCE0
#define UC_DIRP2	0xDCE1

#define UC_ERASETR  0xDEE0
#define UC_ERASEALL 0xDEE1
#define UC_OUTHTML  0xDEE2
#define UC_OPENHIT  0xDEE3

#define SCORE_MAX   9999

static BYTE const s_convTable[] = {
	 0, 2, 5, 1,
	 3, 6, 7, 4,
	 8,10,11, 9,
	12,13,14,
};

static Minimal::ProcessHeapStringT<char> s_label_specific[SWRCHAR_MAX + 1];
static Minimal::ProcessHeapStringT<char> s_label_overall[SWRCHAR_MAX + 1];

static HMENU s_hSysMenu;
static BOOL  s_onReflesh;
static BOOL  s_trDirLeft;	/* ScoreLineW[ɑgݍ񂾕ǂH */
static int   s_tabIndex;

// ^uhbOtbNp
static WNDPROC s_origTabProc;
static HCURSOR s_origCursor;
static int  s_dragTabIndex;
static BOOL s_downBeforeMove;

void OutputToHTML(LPCSTR fileName)
{
	int sum[2];
	int sumAll[2];
	int winRate;
	int n, win, lose;

	TextFileWriter writer;
	if(FAILED(writer.Initialize(fileName)))
		return;

	writer.WriteFormatted(
		"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" "
			"\"http://www.w3.org/TR/html4/loose.dtd\">"
		"<HTML><HEAD>"
			"<TITLE></TITLE>"
			"<META http-equiv=\"content-type\" content=\"text/html; charset=Shift_JIS\">"
			"<STYLE type=\"text/css\">"
			"TABLE{width:%dem;empty-cells:hide;}"
			"TH{width:6em;}"
			"TD{text-align:center;}"
			"</STYLE>"
		"</HEAD>"
		"<BODY>"
		"<TABLE border=\"1\"><TR><TH></TH>",
		(ARRAYSIZE(g_characters) + 1) * 6);

	for(int i = 0; i < ARRAYSIZE(g_characters); ++i)
		writer.WriteFormatted("<TH colspan=\"2\">%s</TH>", g_characters[i].abbr);
	writer.Write("<TH COLSPAN=\"2\">v</TH></TR>");

	sumAll[0] = sumAll[1] = 0;
	for(int i = 0; i < ARRAYSIZE(g_characters); ++i) {
		writer.WriteFormatted("<TR><TH rowspan=\"2\">%s</TH>", g_characters[i].abbr);
		sum[0] = sum[1] = 0;
		for(int j = 0; j < ARRAYSIZE(g_characters); ++j) {
			for(int k = 0; k < 2; ++k) {
				n = ScoreLine_Read(i, j, k);
				sum[k] += n;
				writer.WriteFormatted("<TD>%d</TD>", n);
			}
		}
		for(int k = 0; k < 2; ++k)
			writer.WriteFormatted("<TD>%d</TD>", sum[k]);

		writer.Write("</TR><TR>");
		for(int j = 0; j < ARRAYSIZE(g_characters); ++j) {
			win = ScoreLine_Read(i, j, 0); lose = ScoreLine_Read(i, j, 1);
			if(win + lose == 0) {
				writer.Write("<TD colspan=\"2\">--.--%</TD>");
			} else {
				winRate = MulDiv(win, 10000, win + lose);
				writer.WriteFormatted("<TD colspan=\"2\">%d.%02d%%</TD>", winRate / 100, winRate % 100);
			}
		}
		if(sum[0] + sum[1] == 0) {
			writer.Write("<TD colspan=\"2\">--.--%</TD></TR>");
		} else {
			winRate = MulDiv(sum[0], 10000, sum[0] + sum[1]);
			writer.WriteFormatted("<TD colspan=\"2\">%d.%02d%%</TD></TR>", winRate / 100, winRate % 100);
		}
		sumAll[0] += sum[0]; sumAll[1] += sum[1];
	}
	writer.WriteFormatted(
		"<TR><TD colspan=\"%d\"></TD><TH colspan=\"2\" rowspan=\"2\">v</TH>",
		ARRAYSIZE(g_characters) * 2 - 1);
	writer.WriteFormatted(
		"<TD>%d</TD><TD>%d</TD></TR>",
		sumAll[0], sumAll[1]);
	writer.WriteFormatted(
		"<TR><TD colspan=\"%d\"></TD>",
		ARRAYSIZE(g_characters) * 2 + 1);
	if(sumAll[0] + sumAll[1] == 0) {
		writer.Write("<TD colspan=\"2\">--.--%</TD>");
	} else {
		winRate = ::MulDiv(sumAll[0], 10000, sumAll[0] + sumAll[1]);
		writer.WriteFormatted("<TD colspan=\"2\">%d.%02d%%</TD>", winRate / 100, winRate % 100);
	}
	writer.Write("</TR></TABLE></BODY></HTML>");
}


LRESULT TabCtrl_OnLButtonDown(HWND hWnd, BOOL F, int x, int y, WPARAM wParam)
{
	TC_HITTESTINFO tchi = {{x, y}, TCHT_ONITEM};
	int i = TabCtrl_HitTest(hWnd, &tchi);
	if(i != -1) {
		// fɑI
		TabCtrl_SetCurSel(hWnd, i);
		NMHDR nmhdr = { hWnd, IDC_TAB, TCN_SELCHANGE };
		SendMessage(GetParent(hWnd), WM_NOTIFY, IDC_TAB, (LPARAM)&nmhdr);
		return TRUE;
	} else {
		return ::CallWindowProc(s_origTabProc, hWnd, WM_LBUTTONDOWN, wParam, MAKELONG(x, y));
	}
}

LRESULT TabCtrl_OnMouseMove(HWND hWnd, int x, int y, UINT keyFlags)
{
	if(keyFlags == MK_LBUTTON) {	// hbOmF
		if(!s_origCursor) { // t@[XgCpNg
			TC_HITTESTINFO tchi = {{x, y}, TCHT_ONITEM};
			int i = TabCtrl_HitTest(hWnd, &tchi);
			if(i != -1) {
				s_origCursor = SetCursor(LoadCursor(NULL, IDC_HAND));
				s_dragTabIndex = i;
				TabCtrl_SetCurSel(hWnd, i);
				NMHDR nmhdr = { hWnd, IDC_TAB, TCN_SELCHANGE };
				SendMessage(GetParent(hWnd), WM_NOTIFY, IDC_TAB, (LPARAM)&nmhdr);

				SetCapture(hWnd);
			}
		} else {			// ZJhCpNg
			TC_HITTESTINFO tchi = {{x, y}, TCHT_ONITEM};
			int i = TabCtrl_HitTest(hWnd, &tchi);
			if(i != -1) {	// ͈͓hbO
				SetCursor(LoadCursor(NULL, IDC_HAND));
				if(i != s_dragTabIndex) {
					TC_ITEM item;
					char itemText[64];
					item.mask = TCIF_TEXT | TCIF_PARAM;
					item.pszText = itemText;
					item.cchTextMax = sizeof itemText;
					TabCtrl_GetItem(hWnd, s_dragTabIndex, &item);
					TabCtrl_DeleteItem(hWnd, s_dragTabIndex);
					TabCtrl_InsertItem(hWnd, i, &item);
					s_dragTabIndex = i;
				}
			} else {		// ͈͊OhbO
				// ́A__I`_I
				SetCursor(LoadCursor(NULL, IDC_NO));
			}
		}
	}
	return TRUE;
}

LRESULT TabCtrl_OnLButtonUp(HWND hWnd, int x, int y, WPARAM wParam)
{
	if(s_origCursor) {
		/* J[\AACRɖ߂ */
		ReleaseCapture();
		SetCursor(s_origCursor);
		s_origCursor = NULL;
	}

	return CallWindowProc(s_origTabProc, hWnd, WM_LBUTTONUP, wParam, MAKELONG(x, y));
}


static LRESULT CALLBACK TabCtrl_WindowProc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	switch(Msg) {
	HANDLE_MSG(hWnd, WM_LBUTTONDOWN, TabCtrl_OnLButtonDown);
	HANDLE_MSG(hWnd, WM_MOUSEMOVE, TabCtrl_OnMouseMove);
	HANDLE_MSG(hWnd, WM_LBUTTONUP, TabCtrl_OnLButtonUp);
	default:
		break;
	}
	return CallWindowProc(s_origTabProc, hWnd, Msg, wParam, lParam);
}

static void ScoreLineDialog_RefleshUnit(HWND hDlg, int index, int sumWin, int sumLose, BOOL edittable)
{
	int winRate;

	::SetDlgItemInt(hDlg, IDC_EDIT110 + index * 2, sumWin, FALSE);
	::SetDlgItemInt(hDlg, IDC_EDIT111 + index * 2, sumLose, FALSE);
	::SendDlgItemMessage(hDlg, IDC_EDIT110 + index * 2, EM_SETREADONLY, !edittable, 0);
	::SendDlgItemMessage(hDlg, IDC_EDIT111 + index * 2, EM_SETREADONLY, !edittable, 0);
	::EnableWindow(GetDlgItem(hDlg, IDC_SPIN1 + index * 2), edittable);
	::EnableWindow(GetDlgItem(hDlg, IDC_SPIN1 + 1 + index * 2), edittable);
	if(sumWin + sumLose == 0) {
		::SetDlgItemText(hDlg, IDC_LABELP11 + index, "--.--%");
	} else {
		winRate = MulDiv(sumWin, 10000, sumWin + sumLose);
		;
		::SetDlgItemText(hDlg, IDC_LABELP11 + index, 
			Formatter("%d.%02d%%", winRate / 100, winRate % 100));
	}
}

static void ScoreLineDialog_RefleshLeft(HWND hDlg, int tabIndex)
{
	int i, j;
	int sumWin, sumLose;
	int sumWinAll, sumLoseAll;
	BOOL edittable = ScoreLine_GetReadMode() == SCORELINE_READALL;

	s_onReflesh = TRUE;
	if(tabIndex == 0) {
		for(i = 0; i < ARRAYSIZE(s_label_overall); ++i)
			::SetDlgItemText(hDlg, IDC_LABEL11 + i, s_label_overall[i]);
		sumWinAll = sumLoseAll = 0;
		for(i = 0; i < SWRCHAR_MAX; ++i) {
			sumWin = sumLose = 0;
			for(j = 0; j < SWRCHAR_MAX; ++j) {
				sumWin  += ScoreLine_Read(s_convTable[i], j, 0);
				sumLose += ScoreLine_Read(s_convTable[i], j, 1);
			}
			sumWinAll  += sumWin;
			sumLoseAll += sumLose;

			ScoreLineDialog_RefleshUnit(hDlg, i, sumWin, sumLose, FALSE);
		}
	} else {
		for(i = 0; i < ARRAYSIZE(s_label_specific); ++i)
			::SetDlgItemText(hDlg, IDC_LABEL11 + i, s_label_specific[i]);
		sumWinAll = sumLoseAll = 0;
		for(i = 0; i < SWRCHAR_MAX; ++i) {
			sumWin  = ScoreLine_Read(tabIndex - 1, s_convTable[i], 0);
			sumLose = ScoreLine_Read(tabIndex - 1, s_convTable[i], 1);
			sumWinAll  += sumWin;
			sumLoseAll += sumLose;

			ScoreLineDialog_RefleshUnit(hDlg, i, sumWin, sumLose, edittable);
		}
	}
	ScoreLineDialog_RefleshUnit(hDlg, 15, sumWinAll, sumLoseAll, FALSE);
	s_onReflesh = FALSE;
}

static void ScoreLineDialog_RefleshRight(HWND hDlg, int tabIndex)
{
	int i, j;
	int sumWin, sumLose;
	int sumWinAll, sumLoseAll;
	BOOL edittable = ScoreLine_GetReadMode() == SCORELINE_READALL;

	s_onReflesh = TRUE;
	if(tabIndex == 0) {
		for(i = 0; i < ARRAYSIZE(s_label_specific); ++i)
			::SetDlgItemText(hDlg, IDC_LABEL11 + i, s_label_specific[i]);
		sumWinAll = sumLoseAll = 0;
		for(i = 0; i < SWRCHAR_MAX; ++i) {
			sumWin = sumLose = 0;
			for(j = 0; j < SWRCHAR_MAX; ++j) {
				sumWin  += ScoreLine_Read(j, s_convTable[i], 0);
				sumLose += ScoreLine_Read(j, s_convTable[i], 1);
			}
			sumWinAll  += sumWin;
			sumLoseAll += sumLose;

			ScoreLineDialog_RefleshUnit(hDlg, i, sumWin, sumLose, FALSE);
		}
	} else {
		for(i = 0; i < ARRAYSIZE(s_label_overall); ++i)
			::SetDlgItemText(hDlg, IDC_LABEL11 + i, s_label_overall[i]);
		sumWinAll = sumLoseAll = 0;
		for(i = 0; i < SWRCHAR_MAX; ++i) {
			sumWin  = ScoreLine_Read(s_convTable[i], tabIndex - 1, 0);
			sumLose = ScoreLine_Read(s_convTable[i], tabIndex - 1, 1);
			sumWinAll  += sumWin;
			sumLoseAll += sumLose;

			ScoreLineDialog_RefleshUnit(hDlg, i, sumWin, sumLose, edittable);
		}
	}
	ScoreLineDialog_RefleshUnit(hDlg, 15, sumWinAll, sumLoseAll, FALSE);
	s_onReflesh = FALSE;
}

static void ScoreLineDialog_Reflesh(HWND hDlg, int tabIndex)
{
	Minimal::ProcessHeapStringT<char> baseName;
	baseName = ScoreLine_GetPath();
	::PathStripPath(baseName);
	::PathRemoveExtension(baseName);
	baseName.Repair();
	::SetWindowText(hDlg,
		Formatter(WINDOW_TEXT " - %s",
			static_cast<LPCSTR>(baseName)));

	if(s_trDirLeft) {
		ScoreLineDialog_RefleshLeft(hDlg, tabIndex);
	} else {
		ScoreLineDialog_RefleshRight(hDlg, tabIndex);
	}
}

static void SysMenu_OnClose(HWND hDlg, int x, int y)
{
	ShowWindow(hDlg, SW_HIDE);
}

static void SysMenu_OnShowAll(HWND hDlg)
{
	ScoreLine_SetReadMode(SCORELINE_READALL);
	ScoreLineDialog_Reflesh(hDlg, s_tabIndex);
}

static void SysMenu_OnShowL30(HWND hDlg)
{
	ScoreLine_SetReadMode(SCORELINE_READL30);
	ScoreLineDialog_Reflesh(hDlg, s_tabIndex);
}

static void SysMenu_OnShowL50(HWND hDlg)
{
	ScoreLine_SetReadMode(SCORELINE_READL50);
	ScoreLineDialog_Reflesh(hDlg, s_tabIndex);
}

static void SysMenu_OnShowL100(HWND hDlg)
{
	ScoreLine_SetReadMode(SCORELINE_READL100);
	ScoreLineDialog_Reflesh(hDlg, s_tabIndex);
}

static void SysMenu_OnScoreLineMode(HWND hDlg, int nID, int x, int y)
{
	CheckMenuItem(s_hSysMenu, nID, MF_CHECKED);
	for(int i = UC_SHOWALL; i < UC_SHOWMAX; ++i)
		if(i != nID) ::CheckMenuItem(s_hSysMenu, i, MF_UNCHECKED);
	switch(nID) {
	case UC_SHOWALL:  SysMenu_OnShowAll(hDlg);  break;
	case UC_SHOWL30:  SysMenu_OnShowL30(hDlg);  break;
	case UC_SHOWL50:  SysMenu_OnShowL50(hDlg);  break;
	case UC_SHOWL100: SysMenu_OnShowL100(hDlg); break;
	}
}

static void SysMenu_OnEraseTrackRecord(HWND hDlg, int x, int y)
{
	if(::MessageBox(hDlg, "{ɏ܂H", "ߋΐNA", MB_ICONINFORMATION | MB_YESNO) == IDYES)
	{
		TrackRecord_Clear();
		ScoreLineDialog_Reflesh(hDlg, s_tabIndex);
	}
}

static void SysMenu_OnEraseAll(HWND hDlg, int x, int y)
{
	if(
	::MessageBox(hDlg, "{ɏ܂H", "ׂĂȂƂɂ", MB_ICONINFORMATION | MB_YESNO) == IDYES &&
	::MessageBox(hDlg, "xmF܂B{ɏ܂H", "ׂĂȂƂɂ", MB_ICONINFORMATION | MB_YESNO) == IDYES)
	{
		ScoreLine_Clear();
		TrackRecord_Clear();
		ScoreLineDialog_Reflesh(hDlg, s_tabIndex);
	}

}

static void SysMenu_OnOutputToHTML(HWND hDlg, int x, int y)
{
	char fileName[1025];
	OPENFILENAME ofn;
	::ZeroMemory(&ofn, sizeof ofn);
	ofn.lStructSize = sizeof ofn;
	ofn.hwndOwner = hDlg;
	ofn.lpstrFile = fileName;
	ofn.nMaxFile = sizeof fileName;
	ofn.lpstrDefExt = "html";
	ofn.lpstrFilter = "HTMLt@C (*.html)\0*.html\0";
	ofn.Flags = OFN_OVERWRITEPROMPT | OFN_NOCHANGEDIR;
	fileName[0] = 0;
	if(::GetSaveFileName(&ofn)) {
		OutputToHTML(fileName);
	}
}

static void SysMenu_OnOpenProfile(HWND hDlg, int x, int y)
{
	char fileName[1025];
	OPENFILENAME ofn;
	::ZeroMemory(&ofn, sizeof ofn);
	ofn.lStructSize = sizeof ofn;
	ofn.hwndOwner = hDlg;
	ofn.lpstrFile = fileName;
	ofn.nMaxFile = sizeof fileName;
	ofn.lpstrDefExt = "hit";
	ofn.lpstrFilter = "Hikouseki Trackrecord (*.hit)\0*.hit\0";
	ofn.Flags = OFN_CREATEPROMPT | OFN_NOCHANGEDIR;
	fileName[0] = 0;
	if(::GetOpenFileName(&ofn)) {
		if(ScoreLine_Map(fileName)) {
			ScoreLineDialog_Reflesh(hDlg, s_tabIndex);
		} else {
			MessageBox(hDlg, "vt@C̃}bsOɎs܂B", NULL, MB_OK | MB_ICONSTOP);
		}
	}
}

static void SysMenu_OnDirectionP1(HWND hDlg, int x, int y)
{
	if(!s_trDirLeft) {
		::CheckMenuItem(s_hSysMenu, UC_DIRP1, MF_CHECKED);
		::CheckMenuItem(s_hSysMenu, UC_DIRP2, MF_UNCHECKED);
		s_trDirLeft = TRUE;
		ScoreLineDialog_Reflesh(hDlg, s_tabIndex);
	}
}

static void SysMenu_OnDirectionP2(HWND hDlg, int x, int y)
{
	if(s_trDirLeft) {
		::CheckMenuItem(s_hSysMenu, UC_DIRP1, MF_UNCHECKED);
		::CheckMenuItem(s_hSysMenu, UC_DIRP2, MF_CHECKED);
		s_trDirLeft = FALSE;
		ScoreLineDialog_Reflesh(hDlg, s_tabIndex);
	}
}

static void ScoreLineDialog_InitSysMenu(HWND hDlg)
{
	int itemIndex = 0;
	::InsertMenu(s_hSysMenu, itemIndex++, MF_STRING | MF_BYPOSITION,				UC_OPENHIT,		"vt@Cǂݍ");
	::InsertMenu(s_hSysMenu, itemIndex++, MF_SEPARATOR | MF_BYPOSITION, 0, NULL);
	::InsertMenu(s_hSysMenu, itemIndex++, MF_STRING | MF_BYPOSITION,				UC_DIRP1,		"ʐ");
	::InsertMenu(s_hSysMenu, itemIndex++, MF_STRING | MF_BYPOSITION,				UC_DIRP2,		"ʐ");
	::InsertMenu(s_hSysMenu, itemIndex++, MF_SEPARATOR | MF_BYPOSITION, 0, NULL);
	::InsertMenu(s_hSysMenu, itemIndex++, MF_STRING | MF_BYPOSITION | MF_CHECKED,	UC_SHOWALL,		"SĂ̑ΐ");
	::InsertMenu(s_hSysMenu, itemIndex++, MF_STRING | MF_BYPOSITION,				UC_SHOWL30,		"ߋRȎΐ");
	::InsertMenu(s_hSysMenu, itemIndex++, MF_STRING | MF_BYPOSITION,				UC_SHOWL50,		"ߋTȎΐ");
	::InsertMenu(s_hSysMenu, itemIndex++, MF_STRING | MF_BYPOSITION,				UC_SHOWL100,	"ߋPOȎΐ");
	::InsertMenu(s_hSysMenu, itemIndex++, MF_SEPARATOR | MF_BYPOSITION, 0, NULL);
	::InsertMenu(s_hSysMenu, itemIndex++, MF_STRING | MF_BYPOSITION,				UC_ERASETR,		"ߋΐNA");
	::InsertMenu(s_hSysMenu, itemIndex++, MF_SEPARATOR | MF_BYPOSITION, 0, NULL);
	::InsertMenu(s_hSysMenu, itemIndex++, MF_STRING | MF_BYPOSITION,				UC_ERASEALL,	"ׂĂȂƂɂ");
	::InsertMenu(s_hSysMenu, itemIndex++, MF_SEPARATOR | MF_BYPOSITION, 0, NULL);
	::InsertMenu(s_hSysMenu, itemIndex++, MF_STRING | MF_BYPOSITION,				UC_OUTHTML,		"\HTMLɂďo");
	::InsertMenu(s_hSysMenu, itemIndex++, MF_SEPARATOR | MF_BYPOSITION, 0, NULL);
}

static void ScoreLineDialog_InitTab(HWND hDlg)
{
	HWND hTabCtrl = ::GetDlgItem(hDlg, IDC_TAB);
	TCITEM tcItem;
	::ZeroMemory(&tcItem, sizeof tcItem);
	for(int i = 0; i < ARRAYSIZE(g_characters) + 1; ++i)
		TabCtrl_InsertItem(hTabCtrl, 0, &tcItem);

	tcItem.mask = TCIF_TEXT | TCIF_PARAM;
	for(int i = 0; i < ARRAYSIZE(g_characters) + 1; ++i) {
		int tabId = g_settings.ReadInteger(
			"DefaultDlg.Tab.Arrangement", Formatter("%d", i),
			i);
		if(tabId < 1) {	// VXe
			tcItem.pszText = "S";
			tcItem.lParam = 0;
		} else {	// LN^
			if(tabId > ARRAYSIZE(g_characters))
				tabId = ARRAYSIZE(g_characters);
			tcItem.pszText = (LPSTR)g_characters[tabId - 1].abbr;
			tcItem.lParam = tabId;
		}
		TabCtrl_SetItem(hTabCtrl, i, &tcItem);
	}
	TabCtrl_SetCurSel(hTabCtrl, 0);

	RECT rct;
	GetClientRect(hTabCtrl, &rct);
	TabCtrl_AdjustRect(hTabCtrl, 0, &rct);
	TabCtrl_SetItemSize(hTabCtrl, (rct.right - rct.left) / 8 * 9 / 10, 20);

	s_origTabProc = (WNDPROC)GetWindowLong(hTabCtrl, GWL_WNDPROC);
	SetWindowLong(hTabCtrl, GWL_WNDPROC, (LONG)TabCtrl_WindowProc);
}

void ScoreLineDialog_InitSpin(HWND hDlg)
{
	for(int i = IDC_SPIN1; i <= IDC_SPIN30; ++i) {
		::SendDlgItemMessage(hDlg, i, UDM_SETRANGE, 0, MAKELONG(SCORE_MAX, 0));
	}
}

static BOOL ScoreLineDialog_OnInitDialog(HWND hDlg, HWND hwndFocus, LPARAM lParam)
{
	for(int i = 0; i < SWRCHAR_MAX; ++i) {
		s_label_specific[i] = "vs ";
		s_label_specific[i] += g_characters[s_convTable[i]].full;
		s_label_overall[i] = "with ";
		s_label_overall[i] += g_characters[s_convTable[i]].full;
	}
	s_label_specific[SWRCHAR_MAX] = "v";
	s_label_overall[SWRCHAR_MAX]  = "v";

	s_hSysMenu = ::GetSystemMenu(hDlg, FALSE);
	if(s_hSysMenu == NULL) return FALSE;
	
	ScoreLineDialog_InitSysMenu(hDlg);
	ScoreLineDialog_InitTab(hDlg);
	ScoreLineDialog_InitSpin(hDlg);

	HWND hTabCtrl = ::GetDlgItem(hDlg, IDC_TAB);
	TCITEM tcItem;
	tcItem.mask = TCIF_PARAM;
	TabCtrl_GetItem(hTabCtrl, 
		TabCtrl_GetCurSel(hTabCtrl), &tcItem);

	s_trDirLeft = g_settings.ReadInteger(
		"DefaultDlg.Trackrecord", "DirLeft", 1) != 0;
	::CheckMenuItem(s_hSysMenu, UC_DIRP1,  s_trDirLeft ? MF_CHECKED: MF_UNCHECKED);
	::CheckMenuItem(s_hSysMenu, UC_DIRP2, !s_trDirLeft ? MF_CHECKED: MF_UNCHECKED);

	ScoreLine_SetReadMode(SCORELINE_READALL);
	ScoreLineDialog_Reflesh(hDlg, tcItem.lParam);

	return TRUE;
}

static void ScoreLineDialog_OnSysCommand(HWND hDlg, UINT nID, int x, int y)
{
	if(nID == SC_CLOSE) {
		SysMenu_OnClose(hDlg, x, y);
	} else if(nID >= UC_SHOWALL && nID <= UC_SHOWL100) {
		SysMenu_OnScoreLineMode(hDlg, nID, x, y);
	} else if(nID == UC_ERASETR) {
		SysMenu_OnEraseTrackRecord(hDlg, x, y);
	} else if(nID == UC_ERASEALL) {
		SysMenu_OnEraseAll(hDlg, x, y);
	} else if(nID == UC_OUTHTML) {
		SysMenu_OnOutputToHTML(hDlg, x, y);
	} else if(nID == UC_OPENHIT) {
		SysMenu_OnOpenProfile(hDlg, x, y);
	} else if(nID == UC_DIRP1) {
		SysMenu_OnDirectionP1(hDlg, x, y);
	} else if(nID == UC_DIRP2) {
		SysMenu_OnDirectionP2(hDlg, x, y);
	}
}

static void ScoreLineDialog_OnEditChange(HWND hDlg, int id, HWND hwndCtl)
{
	if(!s_onReflesh && s_tabIndex > 0) {
		int index = (id - IDC_EDIT110);
		if(s_trDirLeft) {
			ScoreLine_Reference(s_tabIndex - 1, s_convTable[index >> 1], index & 1) =
					::SendDlgItemMessage(hDlg, IDC_SPIN1 + index, UDM_GETPOS32, 0, 0);
		} else {
			ScoreLine_Reference(s_convTable[index >> 1], s_tabIndex - 1, index & 1) =
					::SendDlgItemMessage(hDlg, IDC_SPIN1 + index, UDM_GETPOS32, 0, 0);
		}
		ScoreLineDialog_Reflesh(hDlg, s_tabIndex);
	}
}

static void ScoreLineDialog_OnCommand(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify)
{
	if(id >= IDC_EDIT110 && id <= IDC_EDIT431 && codeNotify == EN_CHANGE)
		ScoreLineDialog_OnEditChange(hDlg, id, hwndCtl);
}

static void ScoreLineDialog_OnUpdateScoreLine(HWND hDlg)
{
	ScoreLineDialog_Reflesh(hDlg, s_tabIndex);
}

static LRESULT ScoreLineDialog_OnNotify(HWND hDlg, int idCtrl, LPNMHDR pNMHdr)
{
	TCITEM tcItem;
	if(pNMHdr->idFrom == IDC_TAB) {
		switch(pNMHdr->code) {
		case TCN_SELCHANGE:
			tcItem.mask = TCIF_PARAM;
			TabCtrl_GetItem(pNMHdr->hwndFrom, 
				TabCtrl_GetCurSel(pNMHdr->hwndFrom), &tcItem);
			s_tabIndex = tcItem.lParam;
			ScoreLineDialog_Reflesh(hDlg, s_tabIndex);
			return TRUE;
		}
	}
	return FALSE;
}

static void ScoreLineDialog_OnDestroy(HWND hDlg)
{
	HWND hTabCtrl = ::GetDlgItem(hDlg, IDC_TAB);
	if(s_origTabProc)
		SetWindowLong(hTabCtrl, GWL_WNDPROC, (LONG)s_origTabProc);

	int count = TabCtrl_GetItemCount(hTabCtrl);
	TCITEM tcItem;
	tcItem.mask = TCIF_PARAM;
	for(int i = 0; i < count; ++i) {
		TabCtrl_GetItem(hTabCtrl, i, &tcItem);
		g_settings.WriteInteger(
			"DefaultDlg.Tab.Arrangement", Formatter("%d", i),
			tcItem.lParam);
	}
	/* ܂Ȃ */
	s_tabIndex = 0;
}

BOOL CALLBACK ScoreLineDialog_DlgProc(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	switch(Msg) {
	HANDLE_DLG_MSG(hDlg, WM_INITDIALOG, ScoreLineDialog_OnInitDialog);
	HANDLE_DLG_MSG(hDlg, WM_DESTROY, ScoreLineDialog_OnDestroy);
	HANDLE_DLG_MSG(hDlg, WM_SYSCOMMAND, ScoreLineDialog_OnSysCommand);
	HANDLE_DLG_MSG(hDlg, WM_COMMAND, ScoreLineDialog_OnCommand);
	HANDLE_DLG_MSG(hDlg, WM_NOTIFY, ScoreLineDialog_OnNotify);
	case UM_UPDATESCORELINE: ScoreLineDialog_OnUpdateScoreLine(hDlg); break;
	}
	return FALSE;
}
